'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('semantic-ui-css/semantic.min.css');

require('./orgchart.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * React component capable of displaying org charts
 */


// import '@fortawesome/fontawesome';
// import '@fortawesome/fontawesome-free-solid';

var ReactGcOrgchart = function (_Component) {
  (0, _inherits3.default)(ReactGcOrgchart, _Component);

  function ReactGcOrgchart() {
    (0, _classCallCheck3.default)(this, ReactGcOrgchart);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ReactGcOrgchart.__proto__ || (0, _getPrototypeOf2.default)(ReactGcOrgchart)).call(this));

    _this.element = false;
    _this.state = {
      height: false,
      width: false
    };
    return _this;
  }

  (0, _createClass3.default)(ReactGcOrgchart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.element) {
        // Use clientWidth instead of height if rotated
        var h = this.element.clientHeight;
        var w = this.element.clientWidth;
        var obj = {};
        if (this.state.height !== h) {
          obj.height = h;
        }
        if (this.state.width !== w) {
          obj.width = w;
        }
        if ((0, _keys2.default)(obj).length > 0) {
          // eslint-disable-next-line react/no-did-mount-set-state
          this.setState(obj);
        }
        this.updateHeight();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(next) {
      var orgStructure = this.props.orgStructure;
      var nextStructure = next.orgStructure;

      if ((0, _stringify2.default)(nextStructure) !== (0, _stringify2.default)(orgStructure)) {
        this.updateHeight();
      }
    }
  }, {
    key: 'updateHeight',
    value: function updateHeight() {
      var _this2 = this;

      // Use clientWidth instead of height if rotated
      var h = this.element.clientHeight;
      var w = this.element.clientWidth;
      var func = function func(counter) {
        if (!_this2.element) return;
        var obj = {};
        if (_this2.element.clientHeight !== h) {
          if (_this2.state.height !== _this2.element.clientHeight) {
            obj.height = _this2.element.clientHeight;
          }
        }
        if (_this2.element.clientWidth !== w) {
          if (_this2.state.width !== _this2.element.clientWidth) {
            obj.width = _this2.element.clientWidth;
          }
        }
        if ((0, _keys2.default)(obj).length > 0) {
          _this2.setState(obj);
        } else if (counter < 100) {
          var f = func.bind(_this2, counter + 1);
          setTimeout(f, 10);
        }
      };
      func(1);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          orgStructure = _props.orgStructure,
          subject = _props.subject;


      if (!orgStructure) return null;

      var colCount = function colCount(r, col) {
        if (col.subordinates) {
          return r + col.subordinates.reduce(colCount, 1);
        }
        return r + 1;
      };

      var getLineClass = function getLineClass(pos, total) {
        var part1 = pos % 2 ? 'leftLine' : 'rightLine';
        var part2 = pos > 0 && pos < total - 1 ? 'topLine' : '';
        return part1 + ' ' + part2;
      };

      var tab = 0;
      var nodeStyle = {};
      if (this.props.onClick !== ReactGcOrgchart.defaultProps.onClick) {
        nodeStyle.cursor = 'pointer';
      }
      var createChart = function createChart(obj) {
        tab += 1;
        var subLength = obj.subordinates ? obj.subordinates.length * 2 : 2;
        return _react2.default.createElement(
          'table',
          null,
          _react2.default.createElement(
            'tbody',
            null,
            _react2.default.createElement(
              'tr',
              null,
              _react2.default.createElement(
                'td',
                { colSpan: subLength },
                _react2.default.createElement(
                  'div',
                  {
                    className: 'node ' + (obj.uuid === subject ? 'focused' : ''),
                    onClick: function onClick(e) {
                      _this3.props.onClick(e, obj);
                    },
                    onKeyPress: function onKeyPress(e) {
                      _this3.props.onKeyPress(e, obj);
                    },
                    role: 'button',
                    tabIndex: tab,
                    style: nodeStyle
                  },
                  _react2.default.createElement(
                    'div',
                    { className: 'title' },
                    obj.name
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'content' },
                    obj.orgTier
                  )
                )
              )
            ),
            obj.subordinates ? _react2.default.createElement(
              'tr',
              { className: 'lines' },
              _react2.default.createElement(
                'td',
                { colSpan: subLength },
                _react2.default.createElement('div', { className: 'downLine' })
              )
            ) : null,
            obj.subordinates ? _react2.default.createElement(
              'tr',
              { className: 'lines' },
              new (Function.prototype.bind.apply(Array, [null].concat((0, _toConsumableArray3.default)(Array(subLength)))))().map(function (c, i) {
                return _react2.default.createElement('td', {
                  key: 'L' + obj.uuid + '_' + i // eslint-disable-line
                  , className: getLineClass(i, subLength)
                });
              })
            ) : null,
            obj.subordinates ? _react2.default.createElement(
              'tr',
              { className: 'nodes' },
              obj.subordinates.map(function (sub) {
                return _react2.default.createElement(
                  'td',
                  { colSpan: '2', key: 'N' + obj.uuid + '_' + sub.uuid },
                  createChart(sub)
                );
              })
            ) : null
          )
        );
      };

      var height = this.state.height || 0;
      var width = this.state.width || 0;

      return _react2.default.createElement(
        'div',
        { style: { height: height + 'px', width: width + 'px' } },
        _react2.default.createElement(
          'div',
          { className: 'orgchart t2b', ref: function ref(r) {
              _this3.element = r;
            } },
          createChart(this.props.orgStructure)
        )
      );
    }
  }]);
  return ReactGcOrgchart;
}(_react.Component);

ReactGcOrgchart.defaultProps = {
  subject: undefined,
  onClick: function onClick() {},
  onKeyPress: function onKeyPress() {}
};

var NodePropType = _propTypes2.default.shape({
  /** Unique identifier for the person */
  uuid: _propTypes2.default.string.isRequired,
  /** Name of a person */
  name: _propTypes2.default.string.isRequired,
  /** Organizational tier of the named person */
  orgTier: _propTypes2.default.string,
  /** Subordinates of the named person */
  subordinates: null
});
NodePropType.subordinates = _propTypes2.default.arrayOf(_propTypes2.default.shape(NodePropType));

ReactGcOrgchart.propTypes = {
  /** The organizational structure to display */
  orgStructure: _propTypes2.default.shape({
    /** Unique identifier for the person */
    uuid: _propTypes2.default.string.isRequired,
    /** Name of the person at the top of the organizational chart */
    name: _propTypes2.default.string.isRequired,
    /** Organizational tier of the named person */
    orgTier: _propTypes2.default.string,
    /** Subordinates of the named person */
    subordinates: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      /** Unique identifier for the person */
      uuid: _propTypes2.default.string.isRequired,
      /** Name of a person */
      name: _propTypes2.default.string.isRequired,
      /** Organizational tier of the named person */
      orgTier: _propTypes2.default.string,
      /** Subordinates of the named person */
      subordinates: _propTypes2.default.arrayOf(NodePropType)
    }))
  }).isRequired,
  /** Identifies by `uuid` which node is in focus */
  subject: _propTypes2.default.string,
  /** Handler for click events */
  onClick: _propTypes2.default.func,
  /** Handler for click events */
  onKeyPress: _propTypes2.default.func
};

exports.default = ReactGcOrgchart;
ReactGcOrgchart.__docgenInfo = {
  'description': 'React component capable of displaying org charts',
  'displayName': 'ReactGcOrgchart',
  'methods': [{
    'name': 'updateHeight',
    'docblock': null,
    'modifiers': [],
    'params': [],
    'returns': null
  }],
  'props': {
    'orgStructure': {
      'type': {
        'name': 'shape',
        'value': {
          'uuid': {
            'name': 'string',
            'description': 'Unique identifier for the person',
            'required': true
          },
          'name': {
            'name': 'string',
            'description': 'Name of the person at the top of the organizational chart',
            'required': true
          },
          'orgTier': {
            'name': 'string',
            'description': 'Organizational tier of the named person',
            'required': false
          },
          'subordinates': {
            'name': 'arrayOf',
            'value': {
              'name': 'shape',
              'value': {
                'uuid': {
                  'name': 'string',
                  'description': 'Unique identifier for the person',
                  'required': true
                },
                'name': {
                  'name': 'string',
                  'description': 'Name of a person',
                  'required': true
                },
                'orgTier': {
                  'name': 'string',
                  'description': 'Organizational tier of the named person',
                  'required': false
                },
                'subordinates': {
                  'name': 'arrayOf',
                  'value': {
                    'name': 'custom',
                    'raw': 'NodePropType'
                  },
                  'description': 'Subordinates of the named person',
                  'required': false
                }
              }
            },
            'description': 'Subordinates of the named person',
            'required': false
          }
        }
      },
      'required': true,
      'description': 'The organizational structure to display'
    },
    'subject': {
      'type': {
        'name': 'string'
      },
      'required': false,
      'description': 'Identifies by `uuid` which node is in focus',
      'defaultValue': {
        'value': 'undefined',
        'computed': true
      }
    },
    'onClick': {
      'type': {
        'name': 'func'
      },
      'required': false,
      'description': 'Handler for click events',
      'defaultValue': {
        'value': '() => {}',
        'computed': false
      }
    },
    'onKeyPress': {
      'type': {
        'name': 'func'
      },
      'required': false,
      'description': 'Handler for click events',
      'defaultValue': {
        'value': '() => {}',
        'computed': false
      }
    }
  }
};